#!/usr/bin/perl
##############################################################################
# dictm.cgi
# Dictionary Maker
# Copyright (C) 2004 Yoshio Shimamura (STUDIO Ys)
# Last Modified: 2004-01-29 by Yoshio Shimamura
# Default Character Code : CGI=sjis, DATA=sjis
##############################################################################

require 'jcode.pl';

##############################################################################
# Global Variables and Emmediate Data
##############################################################################
$TITLE = "DICTM";
$HEADER = "<h1>DICTM</h1>";
$RET_ADDR = "../index.html";
$AUTHOR = "<a href=\"http://hp.vector.co.jp/authors/VA004572/\">STUDIO Ys</a>";
$LOCK = "./lock/lock";
$LOCK_WAIT = 30;
$CGI_NAME = "./dictm.cgi";
$DATA_FILE = "./log_dictm.cgi";
@DATA = "";


##############################################################################
# main routine
##############################################################################
&cgi_decode;
$event = $cgi{'event'};
if ($event eq "search") {
    &search;
} elsif ($event eq "show") {
    &show;
} elsif ($event eq "input") {
    &input;
} elsif ($event eq "write") {
    &write;
} elsif ($event eq "edit") {
    &edit;
} elsif ($event eq "update") {
    &update;
} elsif ($event eq "output") {
    &output;
} else {
    &init;
}


##############################################################################
# sub output
##############################################################################
sub output {
    &read_file($DATA_FILE);

    $filename = "dictm.sdic";

    print "Content-type: application/octet-stream\n";
    print "Content-Disposition: attachment; filename=$filename\n";
    print "\n";
    foreach $i (@DATA) {
	$i =~ s/<br>//g;
	@line = split(',', $i);
	print ("<H>$line[1]</H><K>$line[2]</K>$line[3]\n");
    }
}


##############################################################################
# sub edit
##############################################################################
sub edit {
    &read_file($DATA_FILE);

    $record_id = $cgi{'record_id'};
    $record = $DATA[$record_id - 1];
    @field = split(/,/, $record);

    if ($field[4] ne $cgi{'password'}) {
	print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE - error</TITLE></head>
<body>
<a href="$CGI_NAME?event=init">[Up]</a>
<center>Error</center>
<hr>

Password mismatch!<br>
<a href="$CGI_NAME?event=show&record_id=$field[0]">Return</a>

<hr>
<a href="$CGI_NAME?event=init">[Up]</a>
<center><address>$AUTHOR</address></center>
<body>
</html>
EOF
    } else {

	print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE - edit</TITLE></head>
<body>
<a href="$CGI_NAME?event=init">[Up]</a>
<center>Edit</center>
<hr>

<form action="$CGI_NAME" method="post">
<table border="1" width="100%">
<tr><th width="30%" align="left">ID</th><td>$field[0]</td></tr>
<tr><th align="left">Header</th><td><input type="text" name="header" value="$field[1]"></td></tr>
<tr><th align="left">Keyword</th><td><input type="text" name="keyword" value="$field[2]"></td></tr>
<tr><th align="left">Contents</th><td><textarea name="contents" cols=20 rows=5>$field[3]</textarea></td></tr>
</table>
<input type="hidden" name="event" value="update">
<input type="hidden" name="number" value="$field[0]">
Password<br>
<input type="password" name="password" value="$cgi{'password'}"><br>
<input type="submit" value="XVo^">
</form>

<hr>
<a href="$CGI_NAME?event=init">[Up]</a>
<center><address>$AUTHOR</address></center>
<body>
</html>
EOF
    }
}


##############################################################################
# sub update
##############################################################################
sub update {
    local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time());
    $year += 1900;
    $mon += 1;
    if ($mon < 10) { $mon = "0$mon"; }
    if ($mday < 10) { $mday = "0$mday"; }
    if ($hour < 10) { $hour = "0$hour"; }
    if ($min < 10) { $min = "0$min"; }
    if ($sec < 10) { $sec = "0$sec"; }
    $youbi = ("Sun.","Mon.","Tue.","Wed.","Thu.","Fri.","Sat.") [$wday];
    $date_string = "$year-$mon-$mday $youbi $hour:$min:$sec";
    $remote_addr = $ENV{'REMOTE_ADDR'};

    $record_id = $cgi{'number'};
    $record = $record_id - 1;
    $line= "$record_id,$cgi{'header'},$cgi{'keyword'},$cgi{'contents'},$cgi{'password'},$date_string,$remote_addr\n";

    &lock_on;
    &read_file($DATA_FILE);

    splice(@DATA, $record, 1, $line);

    open(FILE, ">$DATA_FILE") || die "cannot write $data_file";
    print FILE @DATA;
    close(FILE);
    &lock_off;
    &update_result;
}


##############################################################################
# update_result
##############################################################################
sub update_result {
	print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE - update</TITLE></head>
<body>
<a href="$CGI_NAME?event=init">[Up]</a>
<center>RESULT</center>
<hr>
<a href="$CGI_NAME?event=init">return</a>
<hr>
<a href="$CGI_NAME?event=init">[Up]</a>
<center><address>$AUTHOR</address></center>
<body></html>
EOF
}


##############################################################################
# write
##############################################################################
sub write {
    &write_data;
    &write_result;
}


##############################################################################
# write_result
##############################################################################
sub write_result {
	print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE - write</TITLE></head>
<body>
<a href="$CGI_NAME?event=init">[Up]</a>
<center>RESULT</center>
<hr>
<a href="$CGI_NAME?event=init">return</a>
<hr>
<a href="$CGI_NAME?event=init">[Up]</a>
<center><address>$AUTHOR</address></center>
<body></html>
EOF
}


##############################################################################
# write data
##############################################################################
sub write_data {
    local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time());
    $year += 1900;
    $mon += 1;
    if ($mon < 10) { $mon = "0$mon"; }
    if ($mday < 10) { $mday = "0$mday"; }
    if ($hour < 10) { $hour = "0$hour"; }
    if ($min < 10) { $min = "0$min"; }
    if ($sec < 10) { $sec = "0$sec"; }
    $youbi = ("Sun.","Mon.","Tue.","Wed.","Thu.","Fri.","Sat.") [$wday];
    $date_string = "$year-$mon-$mday $youbi $hour:$min:$sec";
    $remote_addr = $ENV{'REMOTE_ADDR'};

    open(FILE, $DATA_FILE) || die "cannot read $arg1";
    @DATA = <FILE>;
    close(FILE);
    $number = @DATA + 1; 

    &lock_on;
    open(FILE, ">>$DATA_FILE") || die "cannot write $data_file";
    print FILE "$number,$cgi{'header'},$cgi{'keyword'},$cgi{'contents'},$cgi{'password'},$date_string,$remote_addr\n";
    close(FILE);
    &lock_off;
}


##############################################################################
# lock_on
##############################################################################
sub lock_on {
    $wait = 0;
    while (-f "$LOCK") {
	if ($wait++ >= $LOCK_WAIT) {
	    unlink($LOCK);
	    exit(0);
	}
	sleep(1);
    }
    open(LOCK, ">$LOCK");
    close(LOCK);
}


##############################################################################
# lock_off
##############################################################################
sub lock_off {
    unlink("$LOCK");
}


##############################################################################
# input
##############################################################################
sub input {
	print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE - Input</TITLE></head>
<body>
<a href="$CGI_NAME?event=init">[Up]</a>
<center>$HEADER</center>
<hr>
<form action="$CGI_NAME" method="post">
Header<br>
<input type="text" name="header" value=""><br>
Keyword<br>
<input type="text" name="keyword" value=""><br>
Contents<br>
<textarea name="contents" cols="40" rows="3"></textarea><br>
Password<br>
<input type="password" name="password" value=""><br>
<input type="submit" value="o^s">
<input type="hidden" name="event" value="write">
</form>
<hr>
<a href="$CGI_NAME?event=init">[Up]</a>
<center><address>$AUTHOR</address></center>
<body></html>
EOF
}


##############################################################################
# show
##############################################################################
sub show {
    &read_file($DATA_FILE);

    $record_id = $cgi{'record_id'};
    $record = $DATA[$record_id - 1];
    @field = split(/,/, $record);

    print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE - show</TITLE></head>
<body>
<a href="$CGI_NAME?event=init">[Up]</a>
<hr>

<table border="1" width="100%">
<tr><th width="30%" align="left">ID</th><td>$field[0]</td></tr>
<tr><th align="left">Header</th><td>$field[1]</td></tr>
<tr><th align="left">Keyword</th><td>$field[2]</td></tr>
<tr><th align="left">Comment</th><td>$field[3]</td></tr>
</table>

<form>
<input type="hidden" name="event" value="edit">
<input type="hidden" name="record_id" value="$field[0]">
Password<br>
<input type="password" name="password" value=""><br>
<input type="submit" value="f[^ҏW">
</form>

<hr>
<a href="$CGI_NAME?event=init">[Up]</a>
<center><address>$AUTHOR</address></center>
<body>
</html>
EOF
}


##############################################################################
# search
##############################################################################
sub search {
    &read_file($DATA_FILE);

    $query = $cgi{'query'};
    @result = grep /$query/, @DATA;
    $number = @result;

    print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE</TITLE></head>
<body>
<a href="$CGI_NAME?event=init">[Up]</a>
<center>$HEADER</center>
<hr>
<form action="$CGI_NAME" method="post">
<input type="text" name="query" value="$cgi{'name'}"><br>
<input type="submit" value="s">
<input type="hidden" name="event" value="search">
</form>
EOF

    print "NUM=$number";
    foreach $line (@result) {
	&show_result($line);
    }

    print <<EOF;
<hr>
<a href="$CGI_NAME?event=init">[Up]</a>
<center><address>$AUTHOR</address></center>
<body></html>
EOF
}


##############################################################################
# show_result
##############################################################################
sub show_result {
    local ($line) =@_;
    @field = split(/,/, $line);

    print <<EOF;
<hr>
<a href="$CGI_NAME?event=show&record_id=$field[0]">$field[0]</a>
<strong>$field[1]</strong>
<i>$field[2]</i>
<br>$field[3]
EOF
}


##############################################################################
# init
##############################################################################
sub init {
    print <<EOF;
Content-type: text/html

<html>
<head><TITLE>$TITLE</TITLE></head>
<body>
<a href="$RET_ADDR">[Up]</a>
<center>$HEADER</center>

<hr>
<form action="$CGI_NAME" method="post">
񌟍<br>
<input type="text" name="query" value="$cgi{'query'}"><br>
<input type="submit" value="s">
<input type="hidden" name="event" value="search">
</form>

<form action="$CGI_NAME" method="post">
<input type="submit" value="VKǉ">
<input type="hidden" name="event" value="input">
</form>

<form action="$CGI_NAME" method="post">
<input type="submit" value="o">
<input type="hidden" name="event" value="output">
</form>

<hr>
<a href="$RET_ADDR">[Up]</a>
<center><address>$AUTHOR</address></center>
<body></html>
EOF
}


##############################################################################
# read_file
##############################################################################
sub read_file {
    local($arg1) = @_;
    open(FILE, $arg1) || die "cannot read $arg1";
    @DATA = <FILE>;
    close(FILE);
}


##############################################################################
# cgi_decode
##############################################################################
sub cgi_decode {
	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN, $str, $ENV{'CONTENT_LENGTH'});
	} else {
		$str = $ENV{'QUERY_STRING'};
	}

	@part = split('&', $str);
	foreach $i (@part) {
		($variable, $value) = split('=', $i);
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		&jcode'convert(*value, 'sjis');
		$value =~ s/\r\n/<br>/g;
		$value =~ s/\r/<br>/g;
		$cgi{$variable} = $value;
	}
}	

##############################################################################
# End Of File
##############################################################################
